import * as i0 from '@angular/core';
import { ElementRef, Injectable, Component, ViewChild, Input, Directive, NgModule } from '@angular/core';
import * as Prism from 'prismjs';
import { CommonModule } from '@angular/common';
import 'prismjs/plugins/normalize-whitespace/prism-normalize-whitespace';

class AsPrismService {
    /**
     * @param {ElementRef} el - HTMLELement
     * @param {AsPrismOptions} [options] - Highligher Option
     */
    highlightElement(el, options) {
        if (el instanceof ElementRef) {
            Prism.highlightElement(el.nativeElement, options?.async, options?.callback);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismService, decorators: [{
            type: Injectable
        }] });

class AsPrismComponent {
    constructor(prismService) {
        this.prismService = prismService;
        this.language = 'json';
    }
    ngAfterViewInit() {
        this.prismService.highlightElement(this.codeEle);
    }
    ngOnChanges(changes) {
        if (changes?.code) {
            if (this.codeEle?.nativeElement) {
                this.codeEle.nativeElement.textContent = this.code;
                this.prismService.highlightElement(this.codeEle);
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismComponent, deps: [{ token: AsPrismService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.5", type: AsPrismComponent, selector: "as-prism", inputs: { code: "code", language: "language" }, viewQueries: [{ propertyName: "codeEle", first: true, predicate: ["codeEle"], descendants: true }], usesOnChanges: true, ngImport: i0, template: `
    <pre [class]="'language-' + language">
      <code #codeEle [class]="'language-' + language">{{code}}</code>
    </pre>
  `, isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'as-prism',
                    template: `
    <pre [class]="'language-' + language">
      <code #codeEle [class]="'language-' + language">{{code}}</code>
    </pre>
  `
                }]
        }], ctorParameters: function () { return [{ type: AsPrismService }]; }, propDecorators: { codeEle: [{
                type: ViewChild,
                args: ['codeEle']
            }], code: [{
                type: Input
            }], language: [{
                type: Input
            }] } });

/**
 * @description highlight with directive
 * @DevelopmentApi
 */
class AsPrismDirective {
    constructor(el, asPrismService) {
        this.el = el;
        this.asPrismService = asPrismService;
        this.asPrism = 'json';
        // console.log('el', this.el)
    }
    ngAfterViewInit() {
        this.el.nativeElement.classList.add(`language-${this.asPrism}`);
        // console.log(this.el)
        // this.asPrismService.highlightElement(this.el)
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismDirective, deps: [{ token: i0.ElementRef }, { token: AsPrismService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.5", type: AsPrismDirective, selector: "pre[asPrism]", inputs: { asPrism: "asPrism" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'pre[asPrism]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: AsPrismService }]; }, propDecorators: { asPrism: [{
                type: Input
            }] } });

class AsPrismModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.5", ngImport: i0, type: AsPrismModule, declarations: [AsPrismComponent, AsPrismDirective], imports: [CommonModule], exports: [AsPrismComponent, AsPrismDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismModule, providers: [AsPrismService], imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AsPrismComponent, AsPrismDirective],
                    imports: [CommonModule],
                    exports: [AsPrismComponent, AsPrismDirective],
                    providers: [AsPrismService],
                }]
        }] });

/*
 * Public API Surface of as-prism
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AsPrismComponent, AsPrismDirective, AsPrismModule, AsPrismService };
//# sourceMappingURL=as-prism.mjs.map
